<template>
  <md-card v-if="show" class="md-layout-item md-size-50 md-small-size-100 md-xsmall-size-100">
    <md-card-header>
      <div class="md-title">Debug</div>
    </md-card-header>
    <md-card-content>
      <div class="schema">
        <font-awesome-icon icon="key" size="2x" />
        <svg height="10" width="200" :class="keyBrowserComm">
          <line x1="0" y1="5" x2="200" y2="5" style="stroke:black;stroke-width:2" />
          <circle class="packet" cx="5" cy="5" r="4"/>
        </svg>
        <font-awesome-icon icon="laptop" size="2x" />
        <svg height="10" width="200" :class="browserServerComm">
          <line x1="0" y1="5" x2="200" y2="5" style="stroke:black;stroke-width:2" />
          <circle class="packet" cx="5" cy="5" r="4"/>
        </svg>
        <font-awesome-icon icon="server" size="2x" />
      </div>
      <vue-json-pretty
        class="json"
        :data="message"
        :highlightMouseoverNode="true"
        :deep="1">
      </vue-json-pretty>
      <vue-json-pretty
        class="json"
        :data="detail"
        :highlightMouseoverNode="true"
        :deep="0"
        v-if="detail">
      </vue-json-pretty>
    </md-card-content>
    <md-card-actions>
      <md-button type="submit" class="md-primary" @click="next()" :disabled="working">Next</md-button>
    </md-card-actions>
  </md-card>
</template>

<script>
import { store } from "../store";
import VueJsonPretty from 'vue-json-pretty';
import { CommunicationDirection } from "./communication-direction";

export default {
  name: "Communication",
  components: {
    VueJsonPretty
  },
  props: {
    message: Object,
    detail: Object,
    path: CommunicationDirection,
    working: Boolean
  },
  computed: {
    show: function() {
      return store.debug;
    },
    keyBrowserComm: function() {
      if(this.path == CommunicationDirection.KEY_2_BROWSER) {
        return 'goright';
        } else if(this.path==CommunicationDirection.BROWSER_2_KEY) {
        return 'goleft';
      }
      return '';
    },
    browserServerComm: function() {
      if(this.path == CommunicationDirection.BROWSER_2_SERVER) {
        return 'goright';
      } else if(this.path==CommunicationDirection.SERVER_2_BROWSER) {
        return 'goleft';
      }
      return '';
    }
  },
  filters: {
    pretty: function(value) {
      return JSON.stringify(value, null, 2);
    }
  }, methods: {
    next: function() {
      this.$emit('next');
    }
  }
};
</script>

<style scoped>
.schema {
  display: flex;
  align-items: center;
  justify-content: center;
}
.json {
  background-color: #eafff5;
  margin: 5px;
  padding: 5px;
  overflow: auto;
}
.fa-2x {
  margin-right: 10px;
  margin-left: 10px;
}
</style>

<style>
div.json,
div.json .vjs-tree {
  font-size: 18px;
}
@keyframes goright {
  0% {
    transform: translateX(calc(-100% + 10px));
  }
  100% {
    transform: translateX(0px);
  }
}
@keyframes goleft {
  0% {
    transform: translateX(calc(100% - 10px));
  }
  100% {
    transform: translateX(0px);
  }
}
.packet {
  fill: transparent;
  stroke-width: 0;
}
.goleft .packet {
  animation: goleft 4s ease;
  fill: black;
}
.goright .packet {
  animation: goright 4s ease;
  fill: black;
  cx: calc(100% - 5px);
}
</style>